import { NodeKey, EditorConfig, LexicalNode, LexicalCommand, DOMConversionMap, ElementNode, SerializedLexicalNode, SerializedElementNode } from "lexical";
export declare class VideoNode extends ElementNode {
    __url: string;
    static getType(): string;
    static clone(node: VideoNode): VideoNode;
    constructor(url: string, key?: NodeKey);
    createDOM(config: EditorConfig): HTMLElement;
    static importDOM(): DOMConversionMap | null;
    updateDOM(): false;
    setURL(url: string): void;
    exportJSON(): SerializedElementNode;
    static importJSON(_serializedNode: SerializedLexicalNode): LexicalNode;
}
export declare function $createVideoNode(url: string): VideoNode;
export declare function $isVideoNode(node: LexicalNode | null | undefined): boolean;
type CommandPayload = string;
export declare const INSERT_VIDEO_COMMAND: LexicalCommand<CommandPayload>;
export {};
