import { jsx } from 'react/jsx-runtime';
import { useLexicalComposerContext } from '@lexical/react/LexicalComposerContext';
import { $getRoot } from 'lexical';
import { useState, useLayoutEffect, useEffect } from 'react';
import { L as LexicalHtml_1 } from '../../node_modules/@lexical/html/LexicalHtml.js';

function HeaderPlugin({ placeholder = 'Enter a title...' }) {
    const [editor] = useLexicalComposerContext();
    const [header, setHeder] = useState('');
    const [value, setValue] = useState('');
    useLayoutEffect(() => {
        return editor.registerUpdateListener(() => {
            if (editor) {
                editor.update(() => {
                    const firstNode = $getRoot().getChildAtIndex(0);
                    if (firstNode && firstNode.__tag === 'h1') {
                        console.log(firstNode.getTextContent());
                        setValue(firstNode.getTextContent());
                    }
                });
            }
        });
    }, [editor]);
    useEffect(() => {
        if (editor) {
            if (header) {
                const parser = new DOMParser();
                const dom = parser.parseFromString(`<h1 class=\"editor-heading-h1\"><span>${header}</span></h1>`, 'text/html');
                editor.update(() => {
                    const nodes = LexicalHtml_1.$generateNodesFromDOM(editor, dom);
                    const firstNode = $getRoot().getChildAtIndex(0);
                    if (firstNode) {
                        firstNode.insertBefore(nodes[0]);
                        if (firstNode.__tag === 'h1') {
                            firstNode.remove();
                        }
                    }
                });
            }
        }
    }, [editor, header]);
    return jsx("input", { type: "text", placeholder: placeholder, value: value, onChange: (e) => { setValue(e.currentTarget.value); }, onBlur: () => setHeder(value), autoFocus: true, className: "text-4xl h-24 w-full border-b mb-4 outline-0 px-2" });
}

export { HeaderPlugin };
